To modify Ixia port numbers and IP in pod.yaml
[kvmfornfv.git] / ci / test_kvmfornfv.sh
index 20bdaee..6f6d18e 100755 (executable)
 test_type=$1
 test_name=$2
 ftrace_enable=0
-cyclictest_env_verify=("idle_idle" "cpustress_idle" "memorystress_idle" "iostress_idle") #cyclictest environment
+cyclictest_env_verify=("idle_idle" "memorystress_idle") #cyclictest environment
 cyclictest_env_daily=("idle_idle" "cpustress_idle" "memorystress_idle" "iostress_idle")
 cyclictest_result=0 #exit code of cyclictest
 packetforward_result=0 #exit code of packet forward
+lm_env_verify=("peer-peer" "local")
+livemigration_result=0 #exit code of livemigration
 source $WORKSPACE/ci/envs/host-config
 
+#check if any kernel rpms available for testing
+rpm_count=`ls -1 $WORKSPACE/build_output/*.rpm 2>/dev/null | wc -l`
+if [ $rpm_count = 0 ];then
+   echo "This patch is used for building kernel debian packages required by compass installer and \
+the test environment for testing debain packages is not available"
+   exit 0
+fi
+
 function packetForward {
-#   source $WORKSPACE/ci/packet_forward_test.sh $HOST_IP
-   echo "Packetforwarding need to be implemented"
-   packetforward_result=$?
-   if [ ${packetforward_result} -ne 0 ];then
-      echo "Packet Forwarding test case execution FAILED"
+   #executing packet forwarding test cases based on the job type.
+   if [ ${test_type} == "verify" ];then
+      echo "packet forwarding test cases are not yet implemented for verify job"
+      packetforward_result=0
+   elif [ ${test_type} == "daily" ];then
+      source $WORKSPACE/ci/cyclicTestTrigger.sh $HOST_IP
+      connect_host
+      #Waiting for ssh to be available for the host machine.
+      sleep 20
+      # copy files and rpms and setup environment required for executing test cases
+      setUpPacketForwarding
+      sleep 1
+      #Verifying whether the test node is up and running
+      connect_host
+      sleep 20
+      #Install and Execute packet forwarding test cases
+      runPacketForwarding $test_type
+      packetforward_result=$?
+   else
+      echo "Incorrect test type ${test_type}"
+      exit 1
+   fi
+}
+
+function liveMigration {
+   #executing live migration test case on the host machine
+   test_env=$1
+   test_name=livemigration
+   echo "Test Environment ${test_env}"
+   if [ ${test_env} == "peer-peer" ];then
+      echo "live migration is not implemented for peer to peer"
+   elif [ ${test_env} == "local" ];then
+      source $WORKSPACE/ci/cyclicTestTrigger.sh $HOST_IP
+      connect_host
+      #Update pod.yaml with IP
+      cd $WORKSPACE/tests/
+      sed -ri "s/[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}/${HOST_IP}/" pod.yaml
+      #Cleaning the environment before running Livemigration through yardstick
+      env_clean
+      #Waiting for ssh to be available for the host machine
+      sleep 20
+      if runLiveMigration ${test_env} ${test_name};then
+         livemigration_result=`expr ${livemigration_result} + 0`
+      else
+         echo "live migration test case failed"
+         livemigration_result=`expr ${livemigration_result} + 1`
+      fi
    else
-      echo "Packet Forwarding test case executed SUCCESSFULLY"
+      echo "Incorrect test environment for live migration"
+      exit 1
    fi
-   host_clean
+}
+
+function getTestParams {
+   HOST_IP=$( setHostIP $test_type )
+   test_time=$( setTestTime $test_type )
 }
 
 function cyclictest {
    test_case=$1
+   test_name=cyclictest
    source $WORKSPACE/ci/cyclicTestTrigger.sh $HOST_IP $test_time $test_type $test_case
    #Verifying whether the test node is up and running
    connect_host
    #Waiting for ssh to be available for the host machine.
-   sleep 10
+   sleep 20
    #calculating and verifying sha512sum of the guestimage.
    if ! verifyGuestImage;then
       exit 1
    fi
    #Update kvmfornfv_cyclictest_${testName}.yaml with test_time and pod.yaml with IP
    updateYaml
-   #Cleaning up the test environment before running cyclictest through yardstick.
-   env_clean
    #Running PCM utility
    collect_MBWInfo $test_type
+   #Cleaning the environment before running cyclictest through yardstick
+   env_clean
    #Creating a docker image with yardstick installed and launching ubuntu docker to run yardstick cyclic testcase
-   if runCyclicTest;then
+   if runCyclicTest ${ftrace_enable} ${test_name};then
       cyclictest_result=`expr ${cyclictest_result} + 0`
    else
       echo "Test case execution FAILED for ${test_case} environment"
@@ -59,9 +117,8 @@ function cyclictest {
    echo "Terminating PCM Process"
    sudo ssh root@${HOST_IP} "pid=\$(ps aux | grep 'pcm' | awk '{print \$2}' | head -1); echo \$pid |xargs kill -SIGTERM"
 }
+#Collecting the Memory Bandwidth Information using pcm-memory utility
 function collect_MBWInfo {
-   #Collecting the Memory Bandwidth Information using pcm-memory utility
-   source $WORKSPACE/ci/envs/host-config
    testType=$1
    timeStamp=$(date +%Y%m%d%H%M%S)
    echo "Running PCM memory to collect memory bandwidth"
@@ -69,7 +126,6 @@ function collect_MBWInfo {
    sudo ssh root@${HOST_IP} "${pcm_memory} 60 &>/root/MBWInfo/MBWInfo_${testType}_${timeStamp} &disown"
 }
 function install_pcm {
-   source $WORKSPACE/ci/envs/host-config
    sudo ssh root@${HOST_IP} '
    modelName=`cat /proc/cpuinfo | grep -i "model name" | uniq`
    if echo "$modelName" | grep -i "xeon" ;then
@@ -92,27 +148,17 @@ function install_pcm {
    '
 }
 
-function ftrace_disable {
-   sudo ssh root@${HOST_IP} "sh /root/workspace/scripts/disbale-trace.sh"
-   sudo ssh root@${HOST_IP} "cd /tmp ; a=\$(ls -rt | tail -1) ; echo \$a ; mv \$a cyclictest_${env}.txt"
-   sudo mkdir -p $WORKSPACE/build_output/log/kernel_trace
-   sudo scp root@${HOST_IP}:/tmp/cyclictest_${env}.txt $WORKSPACE/build_output/log/kernel_trace/
-}
-
 #Execution of testcases based on test type and test name from releng.
 if [ ${test_type} == "verify" ];then
-   HOST_IP="10.10.100.21"
-   test_time=1000 # 1s
+   getTestParams
    install_pcm
    if [ ${ftrace_enable} -eq '1' ]; then
       for env in ${cyclictest_env_verify[@]}
       do
          #Enabling ftrace for kernel debugging.
-         sed -i '/host-setup1.sh/a\    \- \"enable-trace.sh\"' kvmfornfv_cyclictest_hostenv_guestenv.yaml
+         sed -i '/host-setup1.sh/a\    \- \"enable-trace.sh\"' $WORKSPACE/tests/kvmfornfv_cyclictest_hostenv_guestenv.yaml
          #Executing cyclictest through yardstick.
          cyclictest ${env}
-         #disabling ftrace and collecting the logs to upload to artifact repository.
-         ftrace_disable
          sleep 10
       done
       #Execution of packet forwarding test cases.
@@ -126,23 +172,33 @@ if [ ${test_type} == "verify" ];then
       done
       #Execution of packet forwarding test cases.
       packetForward
+      for envi in ${lm_env_verify[@]}
+      do
+         echo "Executing Live Migration on the node"
+         liveMigration ${envi}
+      done
+   fi
+   if [ ${cyclictest_result} -ne 0 ] || [ ${packetforward_result} -ne 0 ] || [ ${livemigration_result} -ne 0 ];then
+      echo "Test case FAILED"
+      test_exit 1
+   else
+      test_exit 0
    fi
-      if [ ${cyclictest_result} -ne 0 ] ||  [ ${packetforward_result} -ne 0 ];then
-         echo "Test case FAILED"
-         err_exit 1
-      else
-         err_exit 0
-      fi
 elif [ ${test_type} == "daily" ];then
-   HOST_IP="10.10.100.22"
-   test_time=3600000 #1h
+   getTestParams
    install_pcm
    if [ ${test_name} == "packet_forward" ];then
       packetForward
+      packet_fwd_logs
+      #clean the test environment after the test case execution.
+      sudo ssh root@${HOST_IP} "rm -rf /root/workspace/*"
+      host_clean
       if [ ${packetforward_result} -ne 0 ] ; then
-         err_exit 1
+         echo "Execution of packet forwarding test cases FAILED"
+         packet_fwd_exit 1
       else
-         err_exit 0
+         echo "Executed packet forwarding test cases SUCCESSFULLY"
+         packet_fwd_exit 0
       fi
    elif [ ${test_name} == "cyclictest" ];then
       if [ ${ftrace_enable} -eq '1' ]; then
@@ -152,7 +208,7 @@ elif [ ${test_type} == "daily" ];then
             sed -i '/host-setup1.sh/a\    \- \"enable-trace.sh\"' kvmfornfv_cyclictest_hostenv_guestenv.yaml
             #Executing cyclictest through yardstick.
             cyclictest ${env}
-            #disabling ftrace and collecting the logs to upload to artifact repository. 
+            #disabling ftrace and collecting the logs to upload to artifact repository.
             ftrace_disable
             sleep 5
          done
@@ -166,10 +222,25 @@ elif [ ${test_type} == "daily" ];then
       fi
          if [ ${cyclictest_result} -ne 0 ] ; then
             echo "Cyclictest case execution FAILED"
-            err_exit 1
+            test_exit 1
          else
             echo "Cyclictest case executed SUCCESSFULLY"
-            err_exit 0
+            test_exit 0
+         fi
+   elif [ ${test_name} == "livemigration" ];then
+         for envi in ${lm_env_verify[@]}
+         do
+         echo "Executing Live Migration on the node"
+         liveMigration ${envi}
+         done
+         sudo ssh root@${HOST_IP} "rm -rf /root/workspace/*"
+         host_clean
+         if [ ${livemigration_result} -ne 0 ] ; then
+            echo "livemigration test case execution FAILED"
+            test_exit 1
+         else
+            echo "livemigration test case executed SUCCESSFULLY"
+            test_exit 0
          fi
    fi
 elif [ ${test_type} == "merge" ];then